package be.iminds.ilabt.jfed.restapi;

import be.iminds.ilabt.jfed.restapi.jfedclient.JFedExperimenterApiFactory;
import be.iminds.ilabt.jfed.restapi.jfedclient.JFedExperimenterApiFactoryImpl;
import be.iminds.ilabt.jfed.restapi.resource.SpeakForCredentialParser;
import be.iminds.ilabt.jfed.restapi.resource.SpeakForCredentialParserImpl;
import com.google.inject.AbstractModule;
import com.google.inject.Provides;
import io.dropwizard.setup.Environment;

/**
 * JFedRestApiModule
 */
public class JFedRestApiModule extends AbstractModule {
    private final JFedRestApiConfiguration conf;
    private final Environment environment;

    public JFedRestApiModule(JFedRestApiConfiguration conf, Environment environment) {
        this.conf = conf;
        this.environment = environment;
    }

    @Override
    protected void configure() {
        bind(JFedRestApiConfiguration.class).toInstance(conf);
        bind(Environment.class).toInstance(environment);
    }

    @Provides
    public JFedExperimenterApiFactory providesJFedExperimenterApiFactory(JFedRestApiConfiguration conf) {
      return new JFedExperimenterApiFactoryImpl(conf);
    }

    @Provides
    public SpeakForCredentialParser providesSpeaksForCredentialParser() {
      return new SpeakForCredentialParserImpl();
    }
}
